#include "SDL/SDL.h"
#include <iostream>
#include<time.h>

using namespace std;
void show(int &a, int &b, SDL_Surface*dot,SDL_Surface* screen,SDL_Surface* ab){//Show function to highlight the position of the grid over which mouse
    //is hovering.
//dot refers to the image of the frame corresponding to mouse motion.
SDL_Rect offset;
offset.x =a;//a and b are x and y coordinates of the frame which will respond to mouse motion.
offset.y=b;
SDL_BlitSurface(ab,NULL,screen,NULL);//Unlike show2 function show function does not check each element of array M. Therefore it uses dynamically
//stored image to update screen along with the mouse motion. ab is pointer to dynamically stored image.
SDL_Flip(screen);
SDL_BlitSurface(dot,NULL,screen,&offset);
//Colorkey is set to set a particular color transparent. In this case white color is set transparent.
Uint32 colorkey = SDL_MapRGB( dot->format, 0xFF, 0xFF, 0xFF );
SDL_SetColorKey( dot, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);}


int main( int argc, char* args[] )//Standard call of main function for using SDL.


{SDL_Init( SDL_INIT_EVERYTHING );//Initialising all the functions of SDL.

    //show2 function is responsible to update the images in the maze. It scans a two dimensional array to show images passed as parameter to this function.
void show2(int M[10][10],int &a,int &b,SDL_Surface*reddot,SDL_Surface*greendot,SDL_Surface*twored,SDL_Surface*twogreen,SDL_Surface*threered,
           SDL_Surface*threegreen,SDL_Surface*yellowdot,SDL_Surface*violetdot,
           SDL_Surface*twoyellow,SDL_Surface*twoviolet,SDL_Surface*threeyellow,SDL_Surface*threeviolet,
           SDL_Surface*border,SDL_Surface*crystal,SDL_Surface*paintit,SDL_Surface*frozen,SDL_Surface*destroy,SDL_Surface*screen);

//show function is responsible to highlight the grid being hovered upon by mouse. a and b are coordinates of highlighting frame.
void show(int &a, int &b, SDL_Surface*dot,SDL_Surface* screen,SDL_Surface* ab);
//check function is responsible for checking winning as well as losing condition for a player. If a player wins a game then
//it returns true with one of w5 or w2 or w3 or w4 equal to 1.
bool check(int M[10][10],int &w1,int &w2,int &w3,int &w4,int &w5,int &w6,int &w7,int &w8,int &w9,int &count,int &m,int &n);
//chain2 function is responsible for performing the chain reaction. It is a recursive function. It is also responsible for activating powers.
void chain2(int M[10][10],int &i,int &j,int factor,int &w1,int &w2,int &w3,int &w4,int &w5,int &w6,int &w7,int &w8,int &w9,int &count,int &m,int &n,int &powerfactor);
//Initialising all the integer variables to be used in the program.
int qlast=1;
int mainloop=1;
int c1=1;
int c2=0;
int c3=0;
int c4=0;
int q3=1;
int q4=1;
int q5=1;
int q6=1;
int c5=1;int c6=0;int c7=0;
bool q = true;
bool q2=true;
int a=0;
int b=0;
int i=0;
int j=0;
int factor=0;
int undo[10][10];
int storedfactor;
//Power activation and deactivation  integers
int power1;
int power2;
int power3;
int p1=0;
int p2=0;
int p3=0;
int r1=400;int r2=0;int r5=0;int r6=0;int ti3=0;int r3=0;
int r7=600;int r8=0;int r9=0;int r10=0;int ti4=0;int r11=0;
int r15=500;int r16=0;int r17=0;int r18=0;int ti5=0;int r19=0;
int powerfactor=0;
//integers to define maze size.
int n;int m;
//Main maze matrix.
int M[10][10];
//Integers to be used in check function.
int count=0;
int w1=0;
int w2=0;
int w3=0;
int w4=0;
int w5=0;
int w6=0;
int w7=0;
int w8=0;
int w9=0;
//variables to be used in artificial intelligence.
double ra;
double win=1.000000000000;
double max=0.00000000;
double nred=0.000000;
double ngreen=0.0000000;
int constw2;int constw3;int constw4;int constw9;int constw5;int constw6;int constw7;int constw8;
int N[10][10];
int R[10][10];
int row;
int column;
int x=0;int y=0;
srand (time(NULL));//Random function to obtain random index for powersl
//Declaration of various events like keyboard events, mouse events etc.
SDL_Event e3;
SDL_Event e;
SDL_Event e2;
SDL_Event e5;
SDL_Event event;
//SDL pointers to image files to be used in the game.
SDL_Surface* lastcondition=NULL;
SDL_Surface* ab=NULL;
SDL_Surface* screen2=NULL;
SDL_Surface* screen3=NULL;
SDL_Surface* background = NULL;
SDL_Surface* screen = NULL;
SDL_Surface* dot = NULL;
SDL_Surface* reddot = NULL;
SDL_Surface* border =NULL;
SDL_Surface* greendot = NULL;
SDL_Surface* twogreen = NULL;
SDL_Surface* threegreen = NULL;
SDL_Surface* twored = NULL;
SDL_Surface* threered = NULL;
SDL_Surface* threeviolet = NULL;
SDL_Surface* threeyellow = NULL;
SDL_Surface* twoviolet = NULL;
SDL_Surface* twoyellow = NULL;
SDL_Surface* yellowdot = NULL;
SDL_Surface* violetdot= NULL;
SDL_Surface* player1= NULL;
SDL_Surface* player2= NULL;
SDL_Surface* player3= NULL;
SDL_Surface* player4= NULL;
SDL_Surface* player1highlighted= NULL;
SDL_Surface* player2highlighted= NULL;
SDL_Surface* player3highlighted= NULL;
SDL_Surface* player4highlighted= NULL;
SDL_Surface* destroy=NULL;
SDL_Surface* frozen=NULL;
SDL_Surface* redwins=NULL;
SDL_Surface* yellowwins=NULL;
SDL_Surface* violetwins=NULL;
SDL_Surface* greenwins=NULL;
SDL_Surface* crystal=NULL;
SDL_Surface* rows=NULL;
SDL_Surface* columns=NULL;
SDL_Surface* play=NULL;
SDL_Surface* playhighlighted=NULL;
SDL_Surface* instructions=NULL;
SDL_Surface* instructionshighlighted=NULL;
SDL_Surface* quit=NULL;
SDL_Surface* quithighlighted=NULL;
SDL_Surface* instructionmain2=NULL;
SDL_Surface* paintit=NULL;
//Loading images using the function SDL_LoadBMP.
SDL_Surface* chainwall=SDL_LoadBMP("chainwall.bmp");
lastcondition=SDL_LoadBMP("lastcondition.bmp");
paintit=SDL_LoadBMP("paintit.bmp");
rows=SDL_LoadBMP("rows.bmp");
instructionmain2=SDL_LoadBMP("instructionmain2.bmp");
columns=SDL_LoadBMP("columns.bmp");
background= SDL_LoadBMP("background.bmp");
dot = SDL_LoadBMP("shade2.bmp");
reddot =SDL_LoadBMP("reddot.bmp");
border= SDL_LoadBMP("natural-background-frame.bmp");
greendot=SDL_LoadBMP("greendot.bmp");
twored=SDL_LoadBMP("twored.bmp");
threered=SDL_LoadBMP("threered.bmp");
twogreen=SDL_LoadBMP("twogreen.bmp");
threegreen=SDL_LoadBMP("threegreen.bmp");
threeviolet=SDL_LoadBMP("threeviolet.bmp");
threeyellow=SDL_LoadBMP("threeyellow.bmp");
twoviolet=SDL_LoadBMP("twoviolet.bmp");
twoyellow=SDL_LoadBMP("twoyellow.bmp");
yellowdot=SDL_LoadBMP("yellowdot.bmp");
violetdot=SDL_LoadBMP("violetdot.bmp");
player1=SDL_LoadBMP("1player.bmp");
player2=SDL_LoadBMP("2player.bmp");
player3=SDL_LoadBMP("3player.bmp");
player4=SDL_LoadBMP("4players.bmp");
player1highlighted=SDL_LoadBMP("1playerhighlighted.bmp");
player2highlighted=SDL_LoadBMP("2playerhighlighted.bmp");
player3highlighted=SDL_LoadBMP("3playerhighlighted.bmp");
player4highlighted=SDL_LoadBMP("4playershighlighted.bmp");
redwins=SDL_LoadBMP("redwins.bmp");
greenwins=SDL_LoadBMP("greenwins.bmp");
violetwins=SDL_LoadBMP("violetwins.bmp");
yellowwins=SDL_LoadBMP("yellowwins.bmp");
crystal=SDL_LoadBMP("crystal.bmp");
destroy=SDL_LoadBMP("bomb.bmp");
frozen=SDL_LoadBMP("frozen.bmp");
play=SDL_LoadBMP("play.bmp");
playhighlighted=SDL_LoadBMP("playhighlighted.bmp");
instructions=SDL_LoadBMP("instructions.bmp");
instructionshighlighted=SDL_LoadBMP("instructionshighlighted.bmp");
quit=SDL_LoadBMP("quit.bmp");
quithighlighted=SDL_LoadBMP("quithighlighted.bmp");
screen = SDL_SetVideoMode( 640,480, 32, SDL_SWSURFACE );






//Initialising the matrix M with all elements 0. This implies that initially the maze is empty.
for(int x=0;x<10;x++){
    for(int y=0;y<10;y++){
        M[x][y]=0;
    }
}










while(q6){//The while loop provides user with the options of play, instructions and quit.

      SDL_Init( SDL_INIT_EVERYTHING );
      //setting the screen and blitting with the image chainwall.
      //The function BlitSurface creates an image on the screen.
 screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );SDL_BlitSurface(chainwall,NULL,screen,NULL);
 //Using the function SDL_Rect to set the offsets of the image to be blitted.
    SDL_Rect o1;
    o1.x=49;//x coordinate of image.
    o1.y=90;//y coordinate of image.
    SDL_Rect o2;
    o2.x=49;
    o2.y=190;
    SDL_Rect o3;
    o3.x=49;
    o3.y=290;
    //SDL_SetAlpha provides transparency in the images.
    //c5=1 implies play is highlighted.c6=1 implies instructions is highlighted.  c7=1 implies quit is highlighted.
    if(c5==0){ SDL_SetAlpha( play, SDL_SRCALPHA, 9940 );SDL_BlitSurface(play,NULL,screen,&o1);}else{{SDL_SetAlpha(playhighlighted, SDL_SRCALPHA, 140 );SDL_BlitSurface(playhighlighted,NULL,screen,&o1);}}
    if(c6==0){SDL_SetAlpha( instructions, SDL_SRCALPHA, 9940 );SDL_BlitSurface(instructions,NULL,screen,&o2);}else{{SDL_SetAlpha( instructionshighlighted, SDL_SRCALPHA, 140 );SDL_BlitSurface(instructionshighlighted,NULL,screen,&o2);}}
    if(c7==0){SDL_SetAlpha( quit, SDL_SRCALPHA, 9940 );SDL_BlitSurface(quit,NULL,screen,&o3);}else{{SDL_SetAlpha( quithighlighted, SDL_SRCALPHA, 140 );SDL_BlitSurface(quithighlighted,NULL,screen,&o3);}}
    SDL_Flip(screen);
    if(SDL_PollEvent(&e2)){//Checking if a particular event like mouse click or keyboard key press has occurred.
                     if( e2.type == SDL_KEYDOWN )//If the event is keyboard key press.
                        switch( e2.key.keysym.sym )
                {//If Down key is pressed.
                    case SDLK_DOWN:{if(c5==1){c5=0;c6=1;break;}if(c6==1){c6=0;c7=1;break;}
                    if(c7==1){break;}

                    }
                    //If up key is pressed.
                    case SDLK_UP: {if(c7==1){c7=0;c6=1;break;}if(c6==1){c6=0;c5=1;break;}
                    if(c5==1){break;}

                    }
                    //If Enter key is pressed.
                    case SDLK_RETURN:{q6=0;break;}}
                    //code to show instructions,i.e., if c6=1 and Enter key is pressed.
                    if(c6==1&&q6==0){screen3=SDL_SetVideoMode( 1090, 718, 32, SDL_SWSURFACE );SDL_BlitSurface(instructionmain2,NULL,screen3,NULL);SDL_Flip(screen3);
    while(!q6){
    if(SDL_PollEvent(&e3)){
                     if( e3.type == SDL_KEYDOWN )
                        switch( e3.key.keysym.sym ){case SDLK_RETURN:{q6=1;SDL_Quit();break;}}}}//SDL Quit quits all the SDL function and closes the active
                        //window.
                    }
                     }



}

if(c7==1){return 0;}




if(c5==1){
while(mainloop){
SDL_Init( SDL_INIT_EVERYTHING );//Initializing all the SDL functions.
while(q3){
        //Program to ask for the number of rows.
screen3=SDL_SetVideoMode( 771, 307, 32, SDL_SWSURFACE );//Setting the screen.
SDL_BlitSurface(rows,NULL,screen3,NULL);
SDL_Flip(screen3);
if(SDL_PollEvent(&e3)){
                     if( e3.type == SDL_KEYDOWN )
                        switch( e3.key.keysym.sym )
                {

                case SDLK_1:{m=1;q3=0;SDL_Quit();break;}//If keyboard key 1 is pressed then assign m=1,implying that number of rows is 1.
                case SDLK_2:{m=2;q3=0;SDL_Quit();break;}
                case SDLK_3:{m=3;q3=0;SDL_Quit();break;}
                case SDLK_4:{m=4;q3=0;SDL_Quit();break;}
                case SDLK_5:{m=5;q3=0;SDL_Quit();break;}
                case SDLK_6:{m=6;q3=0;SDL_Quit();break;}
                case SDLK_7:{m=7;q3=0;SDL_Quit();break;}
                case SDLK_8:{m=8;q3=0;SDL_Quit();break;}
                case SDLK_9:{m=9;q3=0;SDL_Quit();break;}
                case SDLK_RETURN:{m=10;q3=0;SDL_Quit();break;}

                }}

}
SDL_Init( SDL_INIT_EVERYTHING );
//Program to ask for the number of columns.
while(q5){
screen=SDL_SetVideoMode( 771, 307, 32, SDL_SWSURFACE );
SDL_BlitSurface(columns,NULL,screen,NULL);
SDL_Flip(screen);
if(SDL_PollEvent(&e5)){
                     if( e5.type == SDL_KEYDOWN )
                        switch( e5.key.keysym.sym )
                {

                case SDLK_1:{n=1;q5=0;SDL_Quit();break;}//If keyboard key 1 is pressed then assign n=1,implying that number of columns is 1.
                case SDLK_2:{n=2;q5=0;SDL_Quit();break;}
                case SDLK_3:{n=3;q5=0;SDL_Quit();break;}
                case SDLK_4:{n=4;q5=0;SDL_Quit();break;}
                case SDLK_5:{n=5;q5=0;SDL_Quit();break;}
                case SDLK_6:{n=6;q5=0;SDL_Quit();break;}
                case SDLK_7:{n=7;q5=0;SDL_Quit();break;}
                case SDLK_8:{n=8;q5=0;SDL_Quit();break;}
                case SDLK_9:{n=9;q5=0;SDL_Quit();break;}
                case SDLK_RETURN:{n=10;q5=0;SDL_Quit();break;}

                }}

}


SDL_Init( SDL_INIT_EVERYTHING );
while(q2){
        //This code segment is responsible for asking various playing options like 1 player, 2 player,etc.
screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );
    SDL_Rect o1;
    o1.x=49;
    o1.y=0;
    SDL_Rect o2;
    o2.x=49;
    o2.y=100;
    SDL_Rect o3;
    o3.x=49;
    o3.y=200;
    SDL_Rect o4;
    o4.x=49;
    o4.y=300;
    if(c1==0){SDL_SetAlpha( player1, SDL_SRCALPHA, 140 );SDL_BlitSurface(player1,NULL,screen,&o1);}else{{SDL_BlitSurface(player1highlighted,NULL,screen,&o1);}}
    if(c2==0){SDL_SetAlpha( player2, SDL_SRCALPHA, 140 );SDL_BlitSurface(player2,NULL,screen,&o2);}else{{SDL_BlitSurface(player2highlighted,NULL,screen,&o2);}}
    if(c3==0){SDL_SetAlpha( player3, SDL_SRCALPHA, 140 );SDL_BlitSurface(player3,NULL,screen,&o3);}else{{SDL_BlitSurface(player3highlighted,NULL,screen,&o3);}}
    if(c4==0){SDL_SetAlpha( player4, SDL_SRCALPHA, 140 );SDL_BlitSurface(player4,NULL,screen,&o4);}else{{SDL_BlitSurface(player4highlighted,NULL,screen,&o4);}}
    SDL_Flip(screen);
    if(SDL_PollEvent(&e2)){
                     if( e2.type == SDL_KEYDOWN )
                        switch( e2.key.keysym.sym )
                {
                    case SDLK_DOWN:{if(c1==1){c1=0;c2=1;break;}if(c2==1){c2=0;c3=1;break;}
                    if(c3==1){c3=0;c4=1;break;}
                    if(c4==1){break;}
                    }
                    case SDLK_UP: {if(c4==1){c4=0;c3=1;break;}if(c2==1){c2=0;c1=1;break;}
                    if(c3==1){c3=0;c2=1;break;}
                    if(c1==1){break;}
                    }
                    case SDLK_RETURN:{q2=false;SDL_Quit();}
                    }
                     }
}




SDL_Init( SDL_INIT_EVERYTHING );
//Setting the screen for the main while loop.The screen size is variable based on the input provided by the user earlier.
//ab is pointer a dynamically stored image. Although in this case ab simply loads already loaded image.
screen = SDL_SetVideoMode( n*64, m*48, 32, SDL_SWSURFACE );SDL_BlitSurface(background,NULL,screen,NULL);ab=SDL_LoadBMP("background.bmp");
     while(q){
if(w2||w3||w4||w5){break;//w2, w3,w4,w5 are variables of check function. If any of them equals to 1, then the game is won by a certain player.
//Hence the main while loop must break.
}

//Code to use powers in the game.
if(c1!=1){
if(r3==0){//The value of r3 is initially 0.
SDL_Delay(10);r1++;if(r1>=900){r2=1;r1=0;}}//r1 increments by 1 with a delay of 10 milliseconds.This implies that after every iteration of the loop
//there is a delay of 10 milliseconds. But this does not affect the performance of the game effectively.This setup allows simultaneous execution of
//two instructions without threading.
if(r2==1){
        //After a delay of approximately 9 second, r2=1.
        //Following code segment checks any random grid which is empty and fills the grid with power.The value for the power allowme is 82.
        //Once power is allocated in a particular grid, then r3=1,implying that there should be no checking of empty grids until a certain period
        //time.It also stops repeated and useless update of screen.
        //The code takes care to automatically remove the power after a certain period of time.
        //If the power is grabbed within a certain period of time then power variable is set to 1 implying that power has been activated.In this case
        //Power variable is power3.
    if(((M[r5][r6]!=0||r5>=m||r6>=n))&&r3==0){r5=(rand()*47)%10;r6=rand()%10;}else{{if(r3==0){M[r5][r6]=82;r3=1;show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,//show2 function declared to update screen afted
                                                                                                                      //a certain element of array is assigned the value of the power.//Dynamic image
                                                                                                                      //storage is used so that screen showing the powers is saved.
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");}if(M[r5][r6]==82&&ti3<10000){SDL_Delay(1);ti3++;}else{ti3=0;if(M[r5][r6]!=82){power3=1;r2=0;}r3=0;M[r5][r6]=0;show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");r5=rand()%10;r6=(rand()*91)%10;
}}}}
//The value for the power mazedestructor is 81.Its power variable is power2.
if(r9==0){
SDL_Delay(10);r7++;if(r7>=1200){r8=1;r7=0;}}
if(r8==1){
    if(((M[r10][r11]!=0||r10>=m||r11>=n))&&r9==0){r10=(rand()*47)%10;r11=rand()%10;}else{{if(r9==0){M[r10][r11]=81;r9=1;show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");}if(M[r10][r11]==81&&ti4<10000){SDL_Delay(1);ti4++;}else{ti4=0;if(M[r10][r11]!=81){power2=1;r8=0;}r9=0;M[r10][r11]=0;show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");r10=rand()%10;r11=(rand()*91)%10;
}}}}



//The value for the power paintit is 80.Its power variable is power1.
if(r17==0){
SDL_Delay(10);r15++;if(r15>=900){r16=1;r15=0;}}
if(r16==1){
    if(((M[r18][r19]!=0||r18>=m||r19>=n))&&r17==0){r18=(rand()*47)%10;r19=rand()%10;}else{{if(r17==0){M[r18][r19]=80;r17=1;show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");}if(M[r18][r19]==80&&ti5<10000){SDL_Delay(1);ti5++;}else{ti5=0;if(M[r18][r19]!=80){power1=1;r16=0;}r17=0;M[r18][r19]=0;show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");r18=rand()%10;r19=(rand()*91)%10;
}}}}
}

//Following code segment is for artificial intelligence.
            if(factor==1&&c1==1){
                    SDL_Delay(1000);
constw2=w2;constw3=w3;constw4=w4;constw5=w5;constw6=w6;constw7=w7;constw8=w8;constw9=w9;//Variables of check function are changed during execution of instructions
//for artificial intelligence which is not desired. Therefore the initial values of all variables are saved.
//Artificial intelligence works on a temporary matrix N[10][10];
    for(int i=0;i<m;i++){
        for(int j=0;j<n;j++){N[i][j]=M[i][j];
        }
    }
  for(int a=0;a<m;a++){
    for(int b=0;b<n;b++){//The game is programmed such that pc always takes green ball. First a green ball is placed at the first valid place(the place
//where there is no red ball) starting from N[0][0]. Then the program place a red ball at each and every possible place and counts the ratio of green balls
//to red balls. It multiplies the ratio for each and every position of red ball and final result is stored in win. The position of the green ball which
//gets maximum value of win is chosen by pc to put its ball.

            x=a;y=b;
            //Program to put a green ball at the first valid location.
            switch(N[a][b]){
case 0:{N[a][b]=8;break;}


                    case 8: {if((((a==0)&&(b==0))||((a==0)&&(b==n-1))||((a==m-1)&&(b==0))||((a==m-1)&&(b==n-1)))) {chain2(N,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    break;}else{N[a][b]=N[a][b]+1;break;}}
                    case 9: {if(((a==0)||(b==0)||(a==m-1)||(b==n-1))){chain2(N,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    break;}else{N[a][b]=N[a][b]+1;break;}}
                    case 10:{chain2(N,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);break;}}
                        for(int i=0;i<m;i++){
        for(int j=0;j<n;j++){R[i][j]=N[i][j];//To put the red balls the program is storing the original matrix N[i][j].
        }
    }factor=0;//factor =0 implies that the program has to input red ball.
    //Program to put a red ball and calculate the ratio in all the possible locations.
                    for(int p=0;p<m;p++){
                        for(int q=0;q<n;q++){
                                x=p;y=q;
                             switch(N[p][q]){
                    case 0: {N[p][q]=1;break;}
                    case 1: {if((((p==0)&&(q==0))||((p==0)&&(q==n-1))||((p==m-1)&&(q==0))||((p==m-1)&&(q==n-1)))) {chain2(N,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    break;}else{N[p][q]=N[p][q]+1;break;}}
                    case 2: {if(((p==0)||(q==0)||(p==m-1)||(q==n-1))){chain2(N,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    break;}else{N[p][q]=N[p][q]+1;break;}}
                    case 3: {chain2(N,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);break;}}
                    for(int g=0;g<m;g++){for(int h=0;h<n;h++){switch(N[g][h]){case 1: {nred=nred+1;break;}case 2: {nred=nred+2;break;}case 3: {nred=nred+3;break;}case 8: {ngreen=ngreen+1;break;}case 9:{ngreen=ngreen+2;break;}case 10:{ngreen=ngreen+3;break;}}}}
                    ra= ngreen/nred;if(ngreen==0){win=0;}else{win=win*ra;}ngreen=0.00000000;nred=0.00000000;
                           for(int i=0;i<m;i++){
        for(int j=0;j<n;j++){N[i][j]=R[i][j];
        }
    } }
    }factor=1;//factor is again set to 1 so that next position of green ball can be calculated.


    if(win>=max){max=win; row=a;column=b;}//maximum value of win has to be considered.
    win=1.000000000;
              for(int i=0;i<m;i++){
        for(int j=0;j<n;j++){N[i][j]=M[i][j];
        }
    }
    }
  }
w2=constw2;w3=constw3;w4=constw4;w5=constw5;w6=constw6;w7=constw7;w8=constw8;w9=constw9;//The value of the variables of check function is restored.
  x=row; y=column;max=0.000000000;
//Following code is to put the green ball in the final position.
  switch(M[row][column]){
case 0:{M[row][column]=8;break;}


                    case 8: {if((((row==0)&&(column==0))||((row==0)&&(column==n-1))||((row==m-1)&&(column==0))||((row==m-1)&&(column==n-1)))) {chain2(M,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    break;}else{M[row][column]=M[row][column]+1;break;}}
                    case 9: {if((((row==0)||(column==n-1)||(row==m-1)||(column==0)))){chain2(M,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    break;}else{M[row][column]=M[row][column]+1;break;}}
                    case 10:{chain2(M,x,y,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);break;}


                    }
                    if((M[row][column]>10||M[row][column]<8)&&M[row][column]>0){while(M[row][column]!=0||row>=m||column>=n){row=rand()%10;column=rand()%10;}M[row][column]=8;}
factor=0;//factor=0 implies that now is the chance for red ball.

show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);



show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);


            SDL_SaveBMP(screen,"save.bmp");
ab=SDL_LoadBMP("save.bmp");count++;

}




if(SDL_PollEvent(&event)){
        //code to sense the mouse motion.
    if( event.type == SDL_MOUSEMOTION ){
         x = event.motion.x;//x and y are offsets of mouse position.
        y = event.motion.y;
                i=x/64;
            j=y/48;
            a=i*64;
b=j*48;{ show(a,b,dot,screen,ab);}

}

 if( event.type == SDL_MOUSEBUTTONDOWN )
    {




        //If the left mouse button was pressed
        if( event.button.button == SDL_BUTTON_LEFT )
        {check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);
            //Get the mouse offsets
            x = event.button.x;
            y = event.button.y;
        j=x/64;
            i=y/48;

{
//Below is the code to place an orb in the maze. Different balls reperesent different values in the matrix.Red balls have value in the range 1 to 3.
//Greenballs have value in the range 8 to 10.
//violet balls have value in the range 13 to 15.
//yellow balls have value in the range 20 to 22.

for(int i=0;i<10;i++){for(int j=0;j<10;j++){undo[i][j]=M[i][j];}} storedfactor=factor;//undo matrix saved before any changes are made by mouseclick.
                        //if power2 is activated.p2 variable keeps count of maximum number of times power can be used.
                        if(power2==1){M[i][j]=-20;p2++;check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);if(p2==2){p2=0;power2=0;}}
                        else{
                            //if power1 is activated.
                            //powerfactor is responsible to give the information to the program that which player has the power.
                        if(power1==1){if(powerfactor==0){
                        if(M[i][j]==8||M[i][j]==13||M[i][j]==20){M[i][j]=1;p1++;}//Change the color of the single ball from any color to the one corresponding to powerfactor 0.
                        if(M[i][j]==9||M[i][j]==14||M[i][j]==21){M[i][j]=2;p1++;}//Change the color of the two balls from any color to the one corresponding to powerfactor 0.
                        if(M[i][j]==10||M[i][j]==15||M[i][j]==22){M[i][j]=3;p1++;}//Change the color of the three balls from any color to the one corresponding to powerfactor 0.
                        if(p1==1){p1=0;power1=0;} //p1 variable keeps count of maximum number of times power can be used.
                        }
                        if(powerfactor==1){
                        if(M[i][j]==1||M[i][j]==13||M[i][j]==20){M[i][j]=8;p1++;}
                        if(M[i][j]==2||M[i][j]==14||M[i][j]==21){M[i][j]=9;p1++;}
                        if(M[i][j]==3||M[i][j]==15||M[i][j]==22){M[i][j]=10;p1++;}
                        if(p1==1){p1=0;power1=0;}
                        }
                        if(powerfactor==2){
                        if(M[i][j]==8||M[i][j]==1||M[i][j]==20){M[i][j]=13;p1++;}
                        if(M[i][j]==9||M[i][j]==2||M[i][j]==21){M[i][j]=14;p1++;}
                        if(M[i][j]==10||M[i][j]==3||M[i][j]==22){M[i][j]=15;p1++;}
                        if(p1==1){p1=0;power1=0;}
                        }
                        if(powerfactor==3){
                        if(M[i][j]==8||M[i][j]==13||M[i][j]==1){M[i][j]=20;p1++;}
                        if(M[i][j]==9||M[i][j]==14||M[i][j]==2){M[i][j]=21;p1++;}
                        if(M[i][j]==10||M[i][j]==15||M[i][j]==3){M[i][j]=22;p1++;}
                        if(p1==1){p1=0;power1=0;}
                        }

check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);
                        }
//if power3 is activated.
//power 3 allows a player to get 3 chances of play.

                        else{if(power3==1){switch(powerfactor){case 0:{switch(M[i][j]){{
case 0: {M[i][j]=1;p3++;break;} //p3 variable keeps count of maximum number of times power can be used.
//special check at corner points.
                    case 1: {if((((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,0,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    //special check at end rows and columns.
                    case 2: {if(((i==0)||(j==0)||(i==m-1)||(j==n-1))){chain2(M,i,j,0,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 3: {chain2(M,i,j,0,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;break;}//chain if number of balls is 3 already.


}}
if(p3==3){p3=0;power3=0;}

break;}
//case 1 of powerfactor implies that the player whose ball values correspond to 8,9,10 has got the power.
case 1:{switch(M[i][j]){{
case 0: {M[i][j]=8;p3++;break;}
                    case 8: {if((((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,1,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 9: {if(((i==0)||(j==0)||(i==m-1)||(j==n-1))){chain2(M,i,j,1,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 10: {chain2(M,i,j,1,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;break;}



}}if(p3==3){p3=0;power3=0;}

break;}


case 2:{switch(M[i][j]){{
case 0: {M[i][j]=13;p3++;break;}
                    case 13: {if((((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,2,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 14: {if(((i==0)||(j==0)||(i==m-1)||(j==n-1))){chain2(M,i,j,2,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 15: {chain2(M,i,j,2,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;break;}

}}if(p3==3){p3=0;power3=0;}

break;}
case 3:{switch(M[i][j]){{
case 0: {M[i][j]=20;p3++;break;}
                    case 20: {if((((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,3,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 21: {if(((i==0)||(j==0)||(i==m-1)||(j==n-1))){chain2(M,i,j,3,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;
                    break;}else{M[i][j]=M[i][j]+1;p3++;break;}}
                    case 22: {chain2(M,i,j,3,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);p3++;break;}



}}if(p3==3){p3=0;power3=0;}

break;}
                        }
                        }

else{//if none of the power is activated.
        //variables w6,w7,w8,w9 decide which players have lost the game and won't play the game further.
        //count calculates the number of times any ball has been placed in the maze.
        //factor is responsible to take care that which player will come after the previous player.
        //factor=0 implies the chance of red ball.
        //factor=1 implies the chance of green ball.
        //factor=2 implies the chance of violet ball.
        //factor=3 implies the chance of yellow ball.
        //c1,c2,c3 decide whether the game is 1 Player of 2 Player or anything else.
        //Checking when number of balls in the particular grid is 0.
                        if((M[i][j]==0)&&(factor%4==0)){M[i][j]=1;if(w7==0||c1==1){factor=1;count++;}else{if(w8==0){factor=2;}else{factor=3;}}count++;}
                    if((M[i][j]==0)&&(factor%4==1)){M[i][j]=8;if(c2==1){factor=0;count++;}else{if(w8==0){factor=2;}else{if(w9==0){factor=3;}else{factor=0;}}count++;}}

                    {if((M[i][j]==0)&&(factor%4==2)){M[i][j]=13;if(c3==1){factor=0;count++;}else{if(w9==0){factor=3;}else{if(w6==0){factor=0;}else{factor=1;}}count++;}}
                    {if((M[i][j]==0)&&(factor%4==3)){M[i][j]=20;if(w6==0){factor=0;}else{if(w7==0){factor=1;}else{factor=2;}}count++;}
                    //Taking special care of corner points when number of balls is 1.
                    if(((M[i][j]==1))&&(factor%4==0)&&(((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(w7==0){factor=1;}else{if(w8==0){factor=2;}else{factor=3;}}count++;}

                    if(((M[i][j]==8))&&(factor%4==1)&&(((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(c2==1){factor=0;count++;}else{if(w8==0){factor=2;}else{if(w9==0){factor=3;}else{factor=0;}count++;}}}

                    if(((M[i][j]==13))&&(factor%4==2)&&(((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                   if(c3==1){factor=0;count++;}else{if(w9==0){factor=3;}else{if(w6==0){factor=0;}else{factor=1;}count++;}}}

                    if(((M[i][j]==20))&&(factor%4==3)&&(((i==0)&&(j==0))||((i==0)&&(j==n-1))||((i==m-1)&&(j==0))||((i==m-1)&&(j==n-1)))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(w6==0){factor=0;}else{if(w7==0){factor=1;}else{factor=2;}}count++;}
                    //Taking special care of end rows and end columns when number of balls is 2.
                    if(((M[i][j]==2))&&(factor%4==0)&&((i==0)||(j==0)||(i==m-1)||(j==n-1))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(w7==0){factor=1;}else{if(w8==0){factor=2;}else{factor=3;}}count++;}

                    if(((M[i][j]==9))&&(factor%4==1)&&((i==0)||(j==0)||(i==m-1)||(j==n-1))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(c2==1){factor=0;count++;}else{{if(w8==0){factor=2;}else{if(w9==0){factor=3;}else{factor=0;}}count++;}}}

                    if(((M[i][j]==14))&&(factor%4==2)&&((i==0)||(j==0)||(i==m-1)||(j==n-1))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(c3==1){factor=0;count++;}else{if(w9==0){factor=3;}else{if(w6==0){factor=0;}else{factor=1;}count++;}}}

                    if(((M[i][j]==21))&&(factor%4==3)&&((i==0)||(j==0)||(i==m-1)||(j==n-1))) {chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);
                    if(w6==0){factor=0;}else{if(w7==0){factor=1;}else{factor=2;}}count++;}
//Remaining cases when number of balls is 1 or 2.
                        if(((M[i][j]==1)||(M[i][j]==2))&&(factor%4==0)) {M[i][j]=M[i][j]+1;
                    if(w7==0){factor=1;}else{if(w8==0){factor=2;}else{factor=3;}}count++;}

                    if(((M[i][j]==8)||(M[i][j]==9))&&(factor%4==1)) {{M[i][j]=M[i][j]+1;
                    if(c2==1){factor=0;}else{if(w8==0){factor=2;}else{if(w9==0){factor=3;}else{factor=0;}}count++;}}}

                    if(((M[i][j]==13)||(M[i][j]==14))&&(factor%4==2)) {{M[i][j]=M[i][j]+1;
                    if(c3==1){factor=0;count++;}else{if(w9==0){factor=3;}else{if(w6==0){factor=0;}else{factor=1;}count++;}}}}

                    if(((M[i][j]==20)||(M[i][j]==21))&&(factor%4==3)) {{M[i][j]=M[i][j]+1;
                    if(w6==0){factor=0;}else{if(w7==0){factor=1;}else{factor=2;}}count++;}}

//Taking special care of the case when the number of balls is 3.
                    if((M[i][j]==3)&&(factor%4==0)){chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);if(w7==0){factor=1;}else{if(w8==0){factor=2;}else{factor=3;}}count++;}
                    if((M[i][j]==10)&&(factor%4==1)){chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);if(c2==1){factor=0;count++;}else{if(w8==0){factor=2;}else{if(w9==0){factor=3;}else{factor=0;}}count++;}}
                    if((M[i][j]==15)&&(factor%4==2)){chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);if(c3==1){factor=0;count++;}else{if(w9==0){factor=3;}else{if(w6==0){factor=0;}else{factor=1;}count++;}}}
                    if((M[i][j]==22)&&(factor%4==3)){chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);if(w6==0){factor=0;}else{if(w7==0){factor=1;}else{factor=2;}}count++;}}




                }}}}}





show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,//Update the screen after changes have been made in the grid.
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);



show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);





            }

            SDL_SaveBMP(screen,"save.bmp");
ab=SDL_LoadBMP("save.bmp");//Dynamically storing image.

            }


             if( event.type == SDL_MOUSEBUTTONDOWN )
    {
        //If the left mouse button was pressed
        if( event.button.button == SDL_BUTTON_RIGHT )
        {//Performing undo operation.
for(int i=0;i<10;i++){for(int j=0;j<10;j++){if(!(M[i][j]>=80))M[i][j]=undo[i][j];}}factor=storedfactor;

       show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen);//Update the screen with images.



show2( M,a,b,  reddot,  greendot,  twored,  twogreen,  threered,
             threegreen,  yellowdot,  violetdot,
             twoyellow,  twoviolet,  threeyellow,  threeviolet,
             border,  crystal,  paintit,  frozen,  destroy,  screen); SDL_SaveBMP(screen,"save.bmp");ab=SDL_LoadBMP("save.bmp");}}


}
else {if(event.type==SDL_QUIT)//If the window is x'd out.
                    {
                      q=false;
                    }
                }


     }
SDL_Delay(1000);//Showing final screen of who wins the game.
     screen2=SDL_SetVideoMode( 506, 263, 32, SDL_SWSURFACE );
if(w2==1){SDL_BlitSurface(redwins,NULL,screen2,NULL);}
if(w3==1){SDL_BlitSurface(greenwins,NULL,screen2,NULL);}
if(w4==1){SDL_BlitSurface(violetwins,NULL,screen2,NULL);}
if(w5==1){SDL_BlitSurface(yellowwins,NULL,screen2,NULL);}
SDL_Flip(screen2);qlast=1;
     SDL_Delay(5000);SDL_Quit();

SDL_Init( SDL_INIT_EVERYTHING );
while(qlast){
screen=SDL_SetVideoMode( 955, 202, 32, SDL_SWSURFACE );SDL_BlitSurface(lastcondition,NULL,screen,NULL);SDL_Flip(screen);
if(SDL_PollEvent(&e)){
    if(e.type==SDL_KEYDOWN){
        switch(e.key.keysym.sym){
       case SDLK_RETURN:{q2=1;q3=1;q5=1;q=1;qlast=0;w1=0;w2=0;w3=0;w4=0;w5=0;w6=0;w7=0;w8=0;w9=0;count=0;factor=0;p1=p2=p3=power1=power2=power3=0;
for(int x=0;x<10;x++){
    for(int y=0;y<10;y++){
        M[x][y]=0;
    }
}break;}
       case SDLK_ESCAPE:{mainloop=0;qlast=0;break;}
        }}}
}
}}}
//chain2 function to perform chain reaction.
//i,j refer to the indices of the grid which is to be chained.
void chain2(int M[10][10],int &i,int &j,int factor,int &w1,int &w2,int &w3,int &w4,int &w5,int &w6,int &w7,int &w8,int &w9,int &count,int &m,int &n,int &powerfactor){

bool check(int M[10][10],int &w1,int &w2,int &w3,int &w4,int &w5,int &w6,int &w7,int &w8,int &w9,int &count,int &m,int &n);
//Check function is being called in chain before starting the chain reaction to see if a particular player has already won the game.
check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);if(check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n)==true){return;}
M[i][j]=0;
switch(factor%4){
//if factor is 0,i.e., it is the chance of red ball.
case 0:{
    //Chain function first of all will make all the surrounding balls of the same color as the color of the ball which starts the chain reaction.
    //In this case the chain function will make all the surroundin balls red colored.
    if((i!=m-1)&&((M[i+1][j]==1)||(M[i+1][j]==8)||(M[i+1][j]==13)||(M[i+1][j]==20))){M[i+1][j]=1;}
    if((i!=0)&&((M[i-1][j]==1)||(M[i-1][j]==8)||(M[i-1][j]==13)||(M[i-1][j]==20))){M[i-1][j]=1;}
    if((j!=n-1)&&((M[i][j+1]==1)||(M[i][j+1]==8)||(M[i][j+1]==13)||(M[i][j+1]==20))){M[i][j+1]=1;}
    if((j!=0)&&((M[i][j-1]==1)||(M[i][j-1]==8)||(M[i][j-1]==13)||(M[i][j-1]==20))){M[i][j-1]=1;}

    if((i!=m-1)&&((M[i+1][j]==2)||(M[i+1][j]==9)||(M[i+1][j]==14)||(M[i+1][j]==21))){M[i+1][j]=2;}
    if((i!=0)&&((M[i-1][j]==2)||(M[i-1][j]==9)||(M[i-1][j]==14)||(M[i-1][j]==21))){M[i-1][j]=2;}
    if((j!=n-1)&&((M[i][j+1]==2)||(M[i][j+1]==9)||(M[i][j+1]==14)||(M[i][j+1]==21))){M[i][j+1]=2;}
    if((j!=0)&&((M[i][j-1]==2)||(M[i][j-1]==9)||(M[i][j-1]==14)||(M[i][j-1]==21))){M[i][j-1]=2;}


if((i!=m-1)&&((M[i+1][j]==3)||(M[i+1][j]==10)||(M[i+1][j]==15)||(M[i+1][j]==22))){M[i+1][j]=3;}
    if((i!=0)&&((M[i-1][j]==3)||(M[i-1][j]==10)||(M[i-1][j]==15)||(M[i-1][j]==22))){M[i-1][j]=3;}
    if((j!=n-1)&&((M[i][j+1]==3)||(M[i][j+1]==10)||(M[i][j+1]==15)||(M[i][j+1]==22))){M[i][j+1]=3;}
    if((j!=0)&&((M[i][j-1]==3)||(M[i][j-1]==10)||(M[i][j-1]==15)||(M[i][j-1]==22))){M[i][j-1]=3;}


//Checking all the cases of the all the surroundind grids.
    if(i!=m-1){switch(M[i+1][j]){case 82: {M[i+1][j]=1;powerfactor=0;break;}//If the surrounding grid consists of powers.
            case 81: {M[i+1][j]=1;powerfactor=0;break;}
            case 80: {M[i+1][j]=1;powerfactor=0;break;}
            //If the surrounding grid consists of balls.
case 0: {M[i+1][j]=1;break;}//If number of balls is 0;
                    case 1: {if((((i+1==0)&&(j==0))||((i+1==0)&&(j==n-1))||((i+1==m-1)&&(j==0))||((i+1==m-1)&&(j==n-1)))) {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}//If number of balls is 1 then special case of corner points is considered.
                    case 2: {if(((i+1==0)||(j==0)||(i+1==m-1)||(j==n-1))){i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}//If number of balls is 2 then special case of end rows and columns is considered.
                    case 3: {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;break;}//If number of balls is 3 then chain.



}}
if(j!=n-1){switch(M[i][j+1]){case 82: {M[i][j+1]=1;powerfactor=0;break;}//Similarly next surrounding grid is considered.
        case 81: {M[i][j+1]=1;powerfactor=0;break;}
        case 80: {M[i][j+1]=1;powerfactor=0;break;}
case 0: {M[i][j+1]=1;break;}
                    case 1: {if((((i==0)&&(j+1==0))||((i==0)&&(j+1==n-1))||((i==m-1)&&(j+1==0))||((i==m-1)&&(j+1==n-1)))) {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 2: {if(((i==0)||(j+1==0)||(i==m-1)||(j+1==n-1))){j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 3: {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;break;}

}}


if(i!=0){switch(M[i-1][j]){case 82: {M[i-1][j]=1;powerfactor=0;break;}
        case 81: {M[i-1][j]=1;powerfactor=0;break;}
        case 80: {M[i-1][j]=1;powerfactor=0;break;}
case 0: {M[i-1][j]=1;break;}
                    case 1: {if((((i-1==0)&&(j==0))||((i-1==0)&&(j==n-1))||((i-1==m-1)&&(j==0))||((i-1==m-1)&&(j==n-1)))) {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 2: {if(((i-1==0)||(j==0)||(i-1==m-1)||(j==n-1))){i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 3: {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;break;}

}}


if(j!=0){switch(M[i][j-1]){case 82: {M[i][j-1]=1;powerfactor=0;break;}
        case 81: {M[i][j-1]=1;powerfactor=0;break;}
        case 80: {M[i][j-1]=1;powerfactor=0;break;}
case 0: {M[i][j-1]=1;break;}
                    case 1: {if((((i==0)&&(j-1==0))||((i==0)&&(j-1==n-1))||((i==m-1)&&(j-1==0))||((i==m-1)&&(j-1==n-1)))) {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 2: {if(((i==0)||(j-1==0)||(i==m-1)||(j-1==n-1))){j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 3: {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;break;}

}}
//check is called at the end of chain function to check that after a chain reaction a particular player has won or a particular player has lost.
check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);
break;
}

case 1:{
{//Making all the surrounding balls green.
    if((i!=m-1)&&((M[i+1][j]==1)||(M[i+1][j]==8)||(M[i+1][j]==13)||(M[i+1][j]==20))){M[i+1][j]=8;}
    if((i!=0)&&((M[i-1][j]==1)||(M[i-1][j]==8)||(M[i-1][j]==13)||(M[i-1][j]==20))){M[i-1][j]=8;}
    if((j!=n-1)&&((M[i][j+1]==1)||(M[i][j+1]==8)||(M[i][j+1]==13)||(M[i][j+1]==20))){M[i][j+1]=8;}
    if((j!=0)&&((M[i][j-1]==1)||(M[i][j-1]==8)||(M[i][j-1]==13)||(M[i][j-1]==20))){M[i][j-1]=8;}

    if((i!=m-1)&&((M[i+1][j]==2)||(M[i+1][j]==9)||(M[i+1][j]==14)||(M[i+1][j]==21))){M[i+1][j]=9;}
    if((i!=0)&&((M[i-1][j]==2)||(M[i-1][j]==9)||(M[i-1][j]==14)||(M[i-1][j]==21))){M[i-1][j]=9;}
    if((j!=n-1)&&((M[i][j+1]==2)||(M[i][j+1]==9)||(M[i][j+1]==14)||(M[i][j+1]==21))){M[i][j+1]=9;}
    if((j!=0)&&((M[i][j-1]==2)||(M[i][j-1]==9)||(M[i][j-1]==14)||(M[i][j-1]==21))){M[i][j-1]=9;}


if((i!=m-1)&&((M[i+1][j]==3)||(M[i+1][j]==10)||(M[i+1][j]==15)||(M[i+1][j]==22))){M[i+1][j]=10;}
    if((i!=0)&&((M[i-1][j]==3)||(M[i-1][j]==10)||(M[i-1][j]==15)||(M[i-1][j]==22))){M[i-1][j]=10;}
    if((j!=n-1)&&((M[i][j+1]==3)||(M[i][j+1]==10)||(M[i][j+1]==15)||(M[i][j+1]==22))){M[i][j+1]=10;}
    if((j!=0)&&((M[i][j-1]==3)||(M[i][j-1]==10)||(M[i][j-1]==15)||(M[i][j-1]==22))){M[i][j-1]=10;}



    if(i!=m-1){switch(M[i+1][j]){case 82:{M[i+1][j]=8;powerfactor=1;break;}
            case 81:{M[i+1][j]=8;powerfactor=1;break;}
            case 80:{M[i+1][j]=8;powerfactor=1;break;}
case 0: {M[i+1][j]=8;break;}
                    case 8: {if((((i+1==0)&&(j==0))||((i+1==0)&&(j==n-1))||((i+1==m-1)&&(j==0))||((i+1==m-1)&&(j==n-1)))) {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}
                    case 9: {if(((i+1==0)||(j==0)||(i+1==m-1)||(j==n-1))){i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}
                    case 10: {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;break;}



}}
if(j!=n-1){switch(M[i][j+1]){case 82:{M[i][j+1]=8;powerfactor=1;break;}
        case 81:{M[i][j+1]=8;powerfactor=1;break;}
        case 80:{M[i][j+1]=8;powerfactor=1;break;}
case 0: {M[i][j+1]=8;break;}
                    case 8: {if((((i==0)&&(j+1==0))||((i==0)&&(j+1==n-1))||((i==m-1)&&(j+1==0))||((i==m-1)&&(j+1==n-1)))) {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 9: {if(((i==0)||(j+1==0)||(i==m-1)||(j+1==n-1))){j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 10: {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;break;}

}}


if(i!=0){switch(M[i-1][j]){case 82:{M[i-1][j]=8;powerfactor=1;break;}
        case 81:{M[i-1][j]=8;powerfactor=1;break;}
        case 80:{M[i-1][j]=8;powerfactor=1;break;}
case 0: {M[i-1][j]=8;break;}
                    case 8: {if((((i-1==0)&&(j==0))||((i-1==0)&&(j==n-1))||((i-1==m-1)&&(j==0))||((i-1==m-1)&&(j==n-1)))) {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 9: {if(((i-1==0)||(j==0)||(i-1==m-1)||(j==n-1))){i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 10: {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;break;}

}}


if(j!=0){switch(M[i][j-1]){case 82:{M[i][j-1]=8;powerfactor=1;break;}
        case 81:{M[i][j-1]=8;powerfactor=1;break;}
        case 80:{M[i][j-1]=8;powerfactor=1;break;}
case 0: {M[i][j-1]=8;break;}
                    case 8: {if((((i==0)&&(j-1==0))||((i==0)&&(j-1==n-1))||((i==m-1)&&(j-1==0))||((i==m-1)&&(j-1==n-1)))) {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 9: {if(((i==0)||(j-1==0)||(i==m-1)||(j-1==n-1))){j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 10: {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;break;}

}}

}check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);
break;
}


 case 2: {
     //Making all the balls violet.
    if((i!=m-1)&&((M[i+1][j]==1)||(M[i+1][j]==8)||(M[i+1][j]==13)||(M[i+1][j]==20))){M[i+1][j]=13;}
    if((i!=0)&&((M[i-1][j]==1)||(M[i-1][j]==8)||(M[i-1][j]==13)||(M[i-1][j]==20))){M[i-1][j]=13;}
    if((j!=n-1)&&((M[i][j+1]==1)||(M[i][j+1]==8)||(M[i][j+1]==13)||(M[i][j+1]==20))){M[i][j+1]=13;}
    if((j!=0)&&((M[i][j-1]==1)||(M[i][j-1]==8)||(M[i][j-1]==13)||(M[i][j-1]==20))){M[i][j-1]=13;}

    if((i!=m-1)&&((M[i+1][j]==2)||(M[i+1][j]==9)||(M[i+1][j]==14)||(M[i+1][j]==21))){M[i+1][j]=14;}
    if((i!=0)&&((M[i-1][j]==2)||(M[i-1][j]==9)||(M[i-1][j]==14)||(M[i-1][j]==21))){M[i-1][j]=14;}
    if((j!=n-1)&&((M[i][j+1]==2)||(M[i][j+1]==9)||(M[i][j+1]==14)||(M[i][j+1]==21))){M[i][j+1]=14;}
    if((j!=0)&&((M[i][j-1]==2)||(M[i][j-1]==9)||(M[i][j-1]==14)||(M[i][j-1]==21))){M[i][j-1]=14;}


if((i!=m-1)&&((M[i+1][j]==3)||(M[i+1][j]==10)||(M[i+1][j]==15)||(M[i+1][j]==22))){M[i+1][j]=15;}
    if((i!=0)&&((M[i-1][j]==3)||(M[i-1][j]==10)||(M[i-1][j]==15)||(M[i-1][j]==22))){M[i-1][j]=15;}
    if((j!=n-1)&&((M[i][j+1]==3)||(M[i][j+1]==10)||(M[i][j+1]==15)||(M[i][j+1]==22))){M[i][j+1]=15;}
    if((j!=0)&&((M[i][j-1]==3)||(M[i][j-1]==10)||(M[i][j-1]==15)||(M[i][j-1]==22))){M[i][j-1]=15;}



    if(i!=m-1){switch(M[i+1][j]){case 82:{M[i+1][j]=13;powerfactor=2;break;}
            case 81:{M[i+1][j]=13;powerfactor=2;break;}
            case 80:{M[i+1][j]=13;powerfactor=2;break;}
case 0: {M[i+1][j]=13;break;}
                    case 13: {if((((i+1==0)&&(j==0))||((i+1==0)&&(j==n-1))||((i+1==m-1)&&(j==0))||((i+1==m-1)&&(j==n-1)))) {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}
                    case 14: {if(((i+1==0)||(j==0)||(i+1==m-1)||(j==n-1))){i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}
                    case 15: {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;break;}



}}
if(j!=n-1){switch(M[i][j+1]){case 82:{M[i][j+1]=13;powerfactor=2;break;}
        case 81:{M[i][j+1]=13;powerfactor=2;break;}
        case 80:{M[i][j+1]=13;powerfactor=2;break;}
case 0: {M[i][j+1]=13;break;}
                    case 13: {if((((i==0)&&(j+1==0))||((i==0)&&(j+1==n-1))||((i==m-1)&&(j+1==0))||((i==m-1)&&(j+1==n-1)))) {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 14: {if(((i==0)||(j+1==0)||(i==m-1)||(j+1==n-1))){j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 15: {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;break;}

}}


if(i!=0){switch(M[i-1][j]){case 82:{M[i-1][j]=13;powerfactor=2;break;}
        case 81:{M[i-1][j]=13;powerfactor=2;break;}
        case 80:{M[i-1][j]=13;powerfactor=2;break;}
case 0: {M[i-1][j]=13;break;}
                    case 13: {if((((i-1==0)&&(j==0))||((i-1==0)&&(j==n-1))||((i-1==m-1)&&(j==0))||((i-1==m-1)&&(j==n-1)))) {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 14: {if(((i-1==0)||(j==0)||(i-1==m-1)||(j==n-1))){i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 15: {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;break;}

}}


if(j!=0){switch(M[i][j-1]){case 82:{M[i][j-1]=13;powerfactor=2;break;}
        case 81:{M[i][j-1]=13;powerfactor=2;break;}
        case 80:{M[i][j-1]=13;powerfactor=2;break;}
case 0: {M[i][j-1]=13;break;}
                    case 13: {if((((i==0)&&(j-1==0))||((i==0)&&(j-1==n-1))||((i==m-1)&&(j-1==0))||((i==m-1)&&(j-1==n-1)))) {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 14: {if(((i==0)||(j-1==0)||(i==m-1)||(j-1==n-1))){j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 15: {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;break;}

}}check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);
break;
}


case 3:{
    //making all the balls yellow.
    if((i!=m-1)&&((M[i+1][j]==1)||(M[i+1][j]==8)||(M[i+1][j]==13)||(M[i+1][j]==20))){M[i+1][j]=20;}
    if((i!=0)&&((M[i-1][j]==1)||(M[i-1][j]==8)||(M[i-1][j]==13)||(M[i-1][j]==20))){M[i-1][j]=20;}
    if((j!=n-1)&&((M[i][j+1]==1)||(M[i][j+1]==8)||(M[i][j+1]==13)||(M[i][j+1]==20))){M[i][j+1]=20;}
    if((j!=0)&&((M[i][j-1]==1)||(M[i][j-1]==8)||(M[i][j-1]==13)||(M[i][j-1]==20))){M[i][j-1]=20;}

    if((i!=m-1)&&((M[i+1][j]==2)||(M[i+1][j]==9)||(M[i+1][j]==14)||(M[i+1][j]==21))){M[i+1][j]=21;}
    if((i!=0)&&((M[i-1][j]==2)||(M[i-1][j]==9)||(M[i-1][j]==14)||(M[i-1][j]==21))){M[i-1][j]=21;}
    if((j!=n-1)&&((M[i][j+1]==2)||(M[i][j+1]==9)||(M[i][j+1]==14)||(M[i][j+1]==21))){M[i][j+1]=21;}
    if((j!=0)&&((M[i][j-1]==2)||(M[i][j-1]==9)||(M[i][j-1]==14)||(M[i][j-1]==21))){M[i][j-1]=21;}


if((i!=m-1)&&((M[i+1][j]==3)||(M[i+1][j]==10)||(M[i+1][j]==15)||(M[i+1][j]==22))){M[i+1][j]=22;}
    if((i!=0)&&((M[i-1][j]==3)||(M[i-1][j]==10)||(M[i-1][j]==15)||(M[i-1][j]==22))){M[i-1][j]=22;}
    if((j!=n-1)&&((M[i][j+1]==3)||(M[i][j+1]==10)||(M[i][j+1]==15)||(M[i][j+1]==22))){M[i][j+1]=22;}
    if((j!=0)&&((M[i][j-1]==3)||(M[i][j-1]==10)||(M[i][j-1]==15)||(M[i][j-1]==22))){M[i][j-1]=22;}



    if(i!=m-1){switch(M[i+1][j]){case 82:{M[i+1][j]=20;powerfactor=3;break;}
            case 81:{M[i+1][j]=20;powerfactor=3;break;}
            case 80:{M[i+1][j]=20;powerfactor=3;break;}
case 0: {M[i+1][j]=20;break;}
                    case 20: {if((((i+1==0)&&(j==0))||((i+1==0)&&(j==n-1))||((i+1==m-1)&&(j==0))||((i+1==m-1)&&(j==n-1)))) {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}
                    case 21: {if(((i+1==0)||(j==0)||(i+1==m-1)||(j==n-1))){i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;
                    break;}else{M[i+1][j]=M[i+1][j]+1;break;}}
                    case 22: {i++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i--;break;}



}}
if(j!=n-1){switch(M[i][j+1]){case 82:{M[i][j+1]=20;powerfactor=3;break;}
        case 81:{M[i][j+1]=20;powerfactor=3;break;}
        case 80:{M[i][j+1]=20;powerfactor=3;break;}
case 0: {M[i][j+1]=20;break;}
                    case 20: {if((((i==0)&&(j+1==0))||((i==0)&&(j+1==n-1))||((i==m-1)&&(j+1==0))||((i==m-1)&&(j+1==n-1)))) {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 21: {if(((i==0)||(j+1==0)||(i==m-1)||(j+1==n-1))){j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;
                    break;}else{M[i][j+1]=M[i][j+1]+1;break;}}
                    case 22: {j++;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j--;break;}

}}


if(i!=0){switch(M[i-1][j]){case 82:{M[i-1][j]=20;powerfactor=3;break;}
        case 81:{M[i-1][j]=20;powerfactor=3;break;}
        case 80:{M[i-1][j]=20;powerfactor=3;break;}
case 0: {M[i-1][j]=20;break;}
                    case 20: {if((((i-1==0)&&(j==0))||((i-1==0)&&(j==n-1))||((i-1==m-1)&&(j==0))||((i-1==m-1)&&(j==n-1)))) {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 21: {if(((i-1==0)||(j==0)||(i-1==m-1)||(j==n-1))){i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;
                    break;}else{M[i-1][j]=M[i-1][j]+1;break;}}
                    case 22: {i--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);i++;break;}

}}


if(j!=0){switch(M[i][j-1]){
        case 82:{M[i][j-1]=20;powerfactor=3;break;}
        case 81:{M[i][j-1]=20;powerfactor=3;break;}
        case 80:{M[i][j-1]=20;powerfactor=3;break;}
case 0: {M[i][j-1]=20;break;}
                    case 20: {if((((i==0)&&(j-1==0))||((i==0)&&(j-1==n-1))||((i==m-1)&&(j-1==0))||((i==m-1)&&(j-1==n-1)))) {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 21: {if(((i==0)||(j-1==0)||(i==m-1)||(j-1==n-1))){j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;
                    break;}else{M[i][j-1]=M[i][j-1]+1;break;}}
                    case 22: {j--;chain2(M,i,j,factor,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n,powerfactor);j++;break;}

}}check(M,w1,w2,w3,w4,w5,w6,w7,w8,w9,count,m,n);
break;
}
}

return;


}


//show2 function is responsible to update the screen with images by scanning the values of array A.
void show2(int M[10][10],int &a,int &b,SDL_Surface*reddot,SDL_Surface*greendot,SDL_Surface*twored,SDL_Surface*twogreen,SDL_Surface*threered,
           SDL_Surface*threegreen,SDL_Surface*yellowdot,SDL_Surface*violetdot,
           SDL_Surface*twoyellow,SDL_Surface*twoviolet,SDL_Surface*threeyellow,SDL_Surface*threeviolet,
           SDL_Surface*border,SDL_Surface*crystal,SDL_Surface*paintit,SDL_Surface*frozen,SDL_Surface*destroy,SDL_Surface*screen){


/*for loop checks each element of array M and assigns an image for different values.*/
            for(int v=0;v<10;v++){
                for(int l=0;l<10;l++){
                    if((M[v][l]==0)){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;

            SDL_BlitSurface(border,NULL,screen,&off);//If value of array is 0 then apply border.
            SDL_Flip(screen);

                    }
                    if(M[v][l]==82){//Apply the image of power for 82.
                        SDL_Rect off;
                        off.x = l*64;//Defining the offset of image to be blitted.
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(crystal,NULL,screen,&off);
            Uint32 colorkey = SDL_MapRGB( crystal->format, 0xFF, 0xFF, 0xFF );//Making white background transparent.
            SDL_SetColorKey( crystal, SDL_SRCCOLORKEY, colorkey );

SDL_Flip(screen);
                    }

                      if(M[v][l]==80){
                        SDL_Rect off;
                        off.x = l*64;







                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(paintit,NULL,screen,&off);
            Uint32 colorkey = SDL_MapRGB( paintit->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( paintit, SDL_SRCCOLORKEY, colorkey );

SDL_Flip(screen);
                    }

                    if(M[v][l]==81){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(destroy,NULL,screen,&off);
            Uint32 colorkey = SDL_MapRGB( destroy->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( destroy, SDL_SRCCOLORKEY, colorkey );

SDL_Flip(screen);
                    }
                    if(M[v][l]==-20){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(frozen,NULL,screen,&off);
            Uint32 colorkey23 = SDL_MapRGB( frozen->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( frozen, SDL_SRCCOLORKEY, colorkey23 );

SDL_Flip(screen);
                    }

                    if(M[v][l]==1){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;

SDL_BlitSurface(border,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( reddot->format, 0xFF, 0xFF, 0xFF );
            SDL_BlitSurface(reddot,NULL,screen,&off);

            SDL_SetColorKey( reddot, SDL_SRCCOLORKEY, colorkey );

SDL_Flip(screen);
                    }
if(M[v][l]==8){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(greendot,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( greendot->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( greendot, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }
                    if(M[v][l]==9){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(twogreen,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( twogreen->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( twogreen, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }
                    if(M[v][l]==10){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(threegreen,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( threegreen->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( threegreen, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }
                    if(M[v][l]==2){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(twored,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( twored->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey(twored, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }
                    if(M[v][l]==3){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(threered,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( threered->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( threered, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }

if(M[v][l]==13){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(violetdot,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( violetdot->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( violetdot, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }

if(M[v][l]==14){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(twoviolet,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( twoviolet->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( twoviolet, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }

                    if(M[v][l]==15){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(threeviolet,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( threeviolet->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( threeviolet, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }

                    if(M[v][l]==20){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(yellowdot,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB( yellowdot->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( yellowdot, SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }


                    if(M[v][l]==21){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(twoyellow,NULL,screen,&off);
Uint32 colorkey = SDL_MapRGB(twoyellow->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey(twoyellow,SDL_SRCCOLORKEY, colorkey );
SDL_Flip(screen);
                    }

                    if(M[v][l]==22){
                        SDL_Rect off;
                        off.x = l*64;
                        off.y =v*48;
                        SDL_BlitSurface(border,NULL,screen,&off);


            SDL_BlitSurface(threeyellow,NULL,screen,&off);
Uint32 colorkey20 = SDL_MapRGB( threeyellow->format, 0xFF, 0xFF, 0xFF );
            SDL_SetColorKey( threeyellow, SDL_SRCCOLORKEY, colorkey20 );
SDL_Flip(screen);
                    }

            }
                }}
//Responsible for checking winning and losing conditions for a player.
  bool check(int M[10][10],int &w1,int &w2,int &w3,int &w4,int &w5,int &w6,int &w7,int &w8,int &w9,int &count,int &m,int &n){


      for(int i=0;i<m;i++){
    for(int j=0;j<n;j++){

        if(count>3){w1=1;}
    }}
//Check function is activated only when all the players have played one time. Count keeps check whether every player had his chance once or not.
    if(w1==1){w2=1;w3=1;w4=1;w5=1;
    //Following code segment is to check whether a particular player has won the game.
  for(int i=0;i<m;i++){
    for(int j=0;j<n;j++){

        if(M[i][j]>3&&M[i][j]<80){w2=0;}//w2 will be equal to 1 if and only if in the maze there is no other ball other than red color.
        if((M[i][j]>10||(M[i][j]<8&&M[i][j]>0))&&M[i][j]<80){w3=0;}//w3 will be equal to 1 if and only if in the maze there is no other ball other than green color.
        if((M[i][j]>15||(M[i][j]<13&&M[i][j]>0))&&M[i][j]<80){w4=0;}//w4 will be equal to 1 if and only if in the maze there is no other ball other than violet color.
        if((M[i][j]>22||(M[i][j]<20&&M[i][j]>0))&&M[i][j]<80){w5=0;}//w5 will be equal to 1 if and only if in the maze there is no other ball other than yellow color.

    }

  }
//Following code segment is to check whether a particular player has lost the game.
  w6=1;w7=1;w8=1;w9=1;
    for(int i=0;i<m;i++){
    for(int j=0;j<n;j++){

        if(M[i][j]<=3&&M[i][j]>0){w6=0;}//w6 will be equal to one if and only if there is no red ball in the maze.
        if(M[i][j]>=8&&M[i][j]<=10){w7=0;}//w7 will be equal to one if and only if there is no green ball in the maze.
        if(M[i][j]>=13&&M[i][j]<=15){w8=0;}//w8 will be equal to one if and only if there is no violet ball in the maze.
        if(M[i][j]>=20&&M[i][j]<=22){w9=0;}//w9 will be equal to one if and only if there is no yellow ball in the maze.

    }

  }
  }
if(w3||w2||w4||w5){return true;}else{return false;}//If any of w3 or w4 or w5 or w2 is 1 then this implies that one player has one and hence the check
//function will return true.

  }
